#include <SDL.h>

#include "image.h"
#include "input.h"
#include "iview.h"
#include "ll.h"
#include "timer.h"

#define MILLIS 2500

SDL_TimerID timer_id;

extern void *imglist;

int
timer_stub ()
{
    if(image_next (1)==0)
	throw_exit();
    show_image ();
    return MILLIS;
}

void
timer_toggle ()
{
    if (timer_id == 0)
	timer_start ();
    else
	timer_stop ();
    return;
}

void
timer_stop ()
{
    if (timer_id != 0)
	if(SDL_RemoveTimer (timer_id) == SDL_FALSE)
		oops("SDL_RemoveTimer() failed\n");

    timer_id = 0;
    return;
}

void
timer_start ()
{
    if (timer_id == 0)
	timer_id =
	    SDL_AddTimer (MILLIS, (SDL_NewTimerCallback) timer_stub, NULL);
    show_image ();
    return;
}
